package com.example.pepat.weatherapp;

import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

public class GetForecastWeather extends AsyncTask<String, Void, ArrayList<String>> {
    private TextView textView3;
    private TextView textView4;
    private TextView textView5;
    private TextView textView6;
    private TextView textView7;
    private TextView textView8;
    private TextView textView9;
    private TextView textView10;
    private ImageView imageView1;
    private ImageView imageView2;
    private ImageView imageView3;
    private ImageView imageView4;
    private  TextView textWind2;
    private  TextView textWind3;
    private  TextView textWind4;
    private  TextView textWind5;
    private ImageView imageWind2;
    private ImageView imageWind3;
    private ImageView imageWind4;
    private ImageView imageWind5;
    private String units;
    private Context context;


    public GetForecastWeather(TextView textView3, TextView textView4, TextView textView5, TextView textView6,
                              TextView textView7, TextView textView8, TextView textView9, TextView textView10,
                              ImageView imageView1, ImageView imageView2, ImageView imageView3, ImageView imageView4,
                              TextView textWind2, TextView textWind3, TextView textWind4, TextView textWind5,
                              ImageView imageWind2, ImageView imageWind3, ImageView imageWind4, ImageView imageWind5,
                              String units, Context context) {
        this.textView3 = textView3;
        this.textView4 = textView4;
        this.textView5 = textView5;
        this.textView6 = textView6;
        this.textView7 = textView7;
        this.textView8 = textView8;
        this.textView9 = textView9;
        this.textView10 = textView10;
        this.imageView1 = imageView1;
        this.imageView2 = imageView2;
        this.imageView3 = imageView3;
        this.imageView4 = imageView4;
        this.textWind2 = textWind2;
        this.textWind3 = textWind3;
        this.textWind4 = textWind4;
        this.textWind5 = textWind5;
        this.imageWind2 = imageWind2;
        this.imageWind3 = imageWind3;
        this.imageWind4 = imageWind4;
        this.imageWind5 = imageWind5;
        this.units = units;
        this.context = context;


    }

    @Override
    protected ArrayList<String> doInBackground(String... params) {
        ArrayList<String> data = new ArrayList<String>();
        try {
            URL url = new URL(params[0]);
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();


            InputStream stream = new BufferedInputStream(urlConnection.getInputStream());
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(stream));
            StringBuilder builder = new StringBuilder();

            String inputString;
            while ((inputString = bufferedReader.readLine()) != null) {
                builder.append(inputString);
            }

            JSONObject jsonObject = new JSONObject(builder.toString());
            Log.d("JsonObject sisältö", jsonObject.toString());

            String mainTxt = "";
            String descriptionTxt = "";
            String weather = "";
            String tempratureTxt = "";
            String main = "";



            JSONArray list = jsonObject.getJSONArray("list");
            Log.i("list", list.toString() );



            for (int i =1; i <= 4; i++){

                JSONObject listObject = list.getJSONObject(i);
                Log.i("listObject", listObject.toString());

                JSONArray weatherInfo = listObject.getJSONArray("weather");
                Log.i("weatherInfo", weatherInfo.toString());
                JSONObject weatherInfoObject = weatherInfo.getJSONObject(0);




                String weatherMain = weatherInfoObject.getString("main");
                String weatherDescription = weatherInfoObject.getString("description");

                JSONObject mainTemp = listObject.getJSONObject("main");
                //String temp = mainTemp.getString("temp");

                Double temp1 = mainTemp.getDouble("temp");


                NumberFormat formatter = new DecimalFormat("#0");

                String temp = formatter.format(temp1);
                Log.i("temp", temp);


                Log.i ("main", weatherMain);
                Log.i ("description", weatherDescription);
                Log.i ("temp", temp);

                weather = weatherMain;
                main = weatherDescription;
                tempratureTxt = temp;


                if (weather != ""){

                    mainTxt += "Day " +i+ ":  " +weather + "\r\n";
                    descriptionTxt += main + "\r\n";
                    tempratureTxt += temp + "\r\n";

                    //Toast.makeText(getBaseContext(), message + " - "
                    // + message,Toast.LENGTH_SHORT).show();

                }

                String time = listObject.getString("dt_txt");

                SimpleDateFormat sdf1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

                SimpleDateFormat sdf2 = new SimpleDateFormat("HH:mm");

                Date date = null;

                try{
                    date = sdf1.parse(time);
                    String newDate = sdf2.format(date);
                    Log.i ("newDate", newDate);
                    data.add(newDate);
                    data.add(temp);
                    data.add(weatherDescription);
                }catch (ParseException e){
                    e.printStackTrace();
                }
                JSONObject mainWind = listObject.getJSONObject("wind");
                Double speed = mainWind.getDouble("speed");
                String windFormat = formatter.format(speed);
                data.add(windFormat);
                try {
                    Integer deg = mainWind.getInt("deg");
                    Log.i("tuuli", speed.toString());
                    Log.i("kulma", deg.toString());
                    data.add(deg.toString());
                }catch (Exception e){
                    data.add("-1");
                }


            }
            urlConnection.disconnect();
        } catch (IOException | JSONException e) {
            e.printStackTrace();
        }
        return data;
    }

    @Override
    protected void onPostExecute(ArrayList<String> dataList) {
        String unitsToText;
        String unitsToWind;
        if(units == "metric"){
            unitsToText = "°C";
            unitsToWind = "m/s";
        }
        else{
            unitsToText = "°F";
            unitsToWind = "mi/h";
        }
        try {
            textView3.setText(dataList.get(0));
            textView4.setText(dataList.get(1) + unitsToText);
            setIcon(imageView1, dataList.get(2), dataList.get(0));
            if(! dataList.get(3).equals("-1")) {
                textWind2.setText(dataList.get(3) + unitsToWind);
                setWindIcon(imageWind2, dataList.get(4));
            }

            textView5.setText(dataList.get(5));
            textView6.setText(dataList.get(6) + unitsToText);
            setIcon(imageView2, dataList.get(7), dataList.get(5));
            if(! dataList.get(8).equals("-1")) {
                textWind3.setText(dataList.get(8) + unitsToWind);
                setWindIcon(imageWind3, dataList.get(9));
            }

            textView7.setText(dataList.get(10));
            textView8.setText(dataList.get(11) + unitsToText);
            setIcon(imageView3, dataList.get(12), dataList.get(10));
            if(! dataList.get(13).equals("-1")) {
                textWind4.setText(dataList.get(13) + unitsToWind);
                setWindIcon(imageWind4, dataList.get(14));
            }

            textView9.setText(dataList.get(15));
            textView10.setText(dataList.get(16) + unitsToText);
            setIcon(imageView4, dataList.get(17), dataList.get(15));
            if(! dataList.get(18).equals("-1")) {
                textWind5.setText(dataList.get(18) + unitsToWind);
                setWindIcon(imageWind5, dataList.get(19));
            }

        }catch (IndexOutOfBoundsException e){
            e.printStackTrace();
            CharSequence text = "No information available";
            int duration = Toast.LENGTH_SHORT;

            Toast toast = Toast.makeText(context, text, duration);
            toast.show();
        }
    }

    protected void setWindIcon(ImageView imageWindIcon, String windDeg){
        int windAngle = Integer.parseInt(windDeg);
        if((0 <= windAngle && windAngle <= 45) || (315 <= windAngle && windAngle <=360)){
            imageWindIcon.setImageResource(R.drawable.tuuli0);
        }
        else if(45 <= windAngle && windAngle <= 135){
            imageWindIcon.setImageResource(R.drawable.tuuli90);
        }
        else if(135 <= windAngle && windAngle <= 225){
            imageWindIcon.setImageResource(R.drawable.tuuli180);
        }
        else{
            imageWindIcon.setImageResource(R.drawable.tuuli270);
        }
    }

    protected void setIcon(ImageView imageViewIcon, String weather, String time){
        String saa;
        Log.i("weatherDescription", weather);
        if(weather.equals("light rain")){
            saa = "sade1";
        }
        else if(weather.equals("moderate rain")){
            saa = "sade2";
        }
        else if(weather.equals("heavy intensite rain")){
            saa = "sade3";
        }
        else if(weather.equals("clear sky")){
            if(time.equals("00:00") || time.equals("03:00")){
                saa = "kuu";
            }
            else {
                saa = "aurinko";
            }
        }
        else if(weather.equals("few clouds")){
            if(time.equals("00:00") || time.equals("03:00")){
                saa = "puolipilvinen_yo";
            }
            else {
                saa = "puolipilvinen";
            }
        }
        else if(weather.equals("scattered clouds")){
            saa = "pilvi";
        }
        else if(weather.equals("broken clouds")){
            saa = "pilvi";
        }
        else if(weather.equals("overcast clouds")){
            saa = "pilvi";
        }
        else{
            saa = "pilvi";
        }
        Log.i("saa",saa);
        switch (saa){
            case "sade1":
                imageViewIcon.setImageResource(R.drawable.sade1);
                break;
            case "sade2":
                imageViewIcon.setImageResource(R.drawable.sade2);
                break;
            case "sade3":
                imageViewIcon.setImageResource(R.drawable.sade3);
                break;
            case "pilvi":
                imageViewIcon.setImageResource(R.drawable.pilvi);
                break;
            case "aurinko":
                imageViewIcon.setImageResource(R.drawable.aurinko);
                break;
            case "puolipilvinen":
                imageViewIcon.setImageResource(R.drawable.puolipilvinen);
                break;

            case "kuu":
                imageViewIcon.setImageResource(R.drawable.kuu);
                break;
            case "puolipilvinen_yo":
                imageViewIcon.setImageResource(R.drawable.puolipilvinen_yo);
                break;
        }
    }
}
